
Redmine - Patch #16069

Allow configuration of API limit instead of hardcoding at 100

2014-02-10 23:27 - Domingo Galdos

Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: REST API Estimated time: 0.00 hour

Target version: Candidate for next major release   

Description

The below tested patch makes the previously harcoded limit of 100 items in a RESTful API response configurable in the

Administration GUI. The default value is still 100. This is based on 2.4.1.stable.

This is quite useful since it is nice and simple to just get the full response in a single page rather than having to traverse pagination,

and a limit of a bit more than 100 is still very performant for many sites -- the limit beyond which performance starts to degrade really

depends on the particular site's usage, so should be controllable by the local administrator.

Index: app/controllers/application_controller.rb

===================================================================

--- app/controllers/application_controller.rb       (.../trunk/app) (revision 13385)

+++ app/controllers/application_controller.rb       (.../branches/code-8112/app)    (revision 1338

9)

@@ -519,8 +519,8 @@

     limit = options[:limit].to_i

     if limit < 1

       limit = 25

-    elsif limit > 100

-      limit = 100

+    elsif limit > Setting.api_limit.to_i

+      limit = Setting.api_limit.to_i

     end

     if offset.nil? && options[:page].present?

       offset = (options[:page].to_i - 1) * limit

Index: app/views/settings/_general.html.erb

===================================================================

--- app/views/settings/_general.html.erb    (.../trunk/app) (revision 13385)

+++ app/views/settings/_general.html.erb    (.../branches/code-8112/app)    (revision 13389)

@@ -24,6 +24,8 @@

 <p><%= setting_select :wiki_compression, [['Gzip', 'gzip']], :blank => :label_none %></p>

+<p><%= setting_text_field :api_limit, :size => 6 %></p>

+

 <p><%= setting_text_field :feeds_limit, :size => 6 %></p>

 <p><%= setting_text_field :file_max_size_displayed, :size => 6 %> <%= l(:"number.human.storage_un

its.units.kb") %></p>

Index: config/settings.yml

===================================================================

--- config/settings.yml        (revision 13387)

+++ config/settings.yml        (revision 13389)

@@ -73,6 +73,9 @@

   default: localhost:3000

 protocol:

   default: http

+api_limit:

+  format: int

+  default: 100

 feeds_limit:

   format: int

   default: 15

Index: config/locales/en.yml
===================================================================

--- config/locales/en.yml      (revision 13387)

+++ config/locales/en.yml      (revision 13389)

@@ -352,6 +352,7 @@

   setting_host_name: Host name and path

   setting_text_formatting: Text formatting

   setting_wiki_compression: Wiki history compression

+  setting_api_limit: Maximum number of items returned in a JSON/XML API response

   setting_feeds_limit: Maximum number of items in Atom feeds

   setting_default_projects_public: New projects are public by default

   setting_autofetch_changesets: Fetch commits automatically

Related issues:

Related to Redmine - Feature #38173: Increase limit of entries in json/xml an... Closed

Has duplicate Redmine - Feature #7539: Rest-API limit of items not 100, but c... Closed 2011-02-04

Has duplicate Redmine - Defect #25555: Make api paging limit configurable Closed

Has duplicate Redmine - Feature #26553: Overly restricted number of ReST results Closed

Has duplicate Redmine - Feature #33526: Add possibility to configure limit us... Closed

History

#1 - 2014-08-19 20:45 - Domingo Galdos

Is there anything I can do to help move this patch forward?

#2 - 2015-07-03 16:22 - Anton Statutov

+1

#3 - 2015-07-10 11:52 - V Lindell

+1

#4 - 2015-07-26 04:08 - Toshi MARUYAMA

- Target version set to 3.2.0

#5 - 2015-07-26 08:50 - Go MAEDA

The user should not be able to set the value of API limit smaller than 100.

Probably some clients suppose that the value is always 100, smaller limit may affect compatibility with such clients.

#6 - 2015-11-22 17:10 - Jens Peter Kempkes

We would also appreciate higher values than 100. Some of our tools need to load all items visible to a user and therefore need to split the requests.

#7 - 2015-11-27 08:57 - Sebastian Paluch

+1

#8 - 2015-12-06 11:44 - Jean-Philippe Lang

- Target version changed from 3.2.0 to Candidate for next major release

#9 - 2015-12-09 13:24 - Jens Peter Kempkes

Too sad, this patch was shifted.

What is the reason?

We're really waiting for this patch and all seems to be done. Am I wrong?

#10 - 2015-12-23 11:00 - Niklaus Jordi

+1

#11 - 2016-03-22 12:38 - Go MAEDA

- Has duplicate Feature #7539: Rest-API limit of items not 100, but changeable by the administrator added

#12 - 2016-06-28 17:54 - Dam Dam

+1
Hi,

This request was posted 2 years ago, so what's up?

#13 - 2016-09-20 09:21 - Stephane Evr

+1

#14 - 2017-04-09 02:18 - Go MAEDA

- Has duplicate Defect #25555: Make api paging limit configurable added

#15 - 2017-04-10 09:55 - George Brooke

Is there anything wrong/non-ideal with this patch which means that it has not been integrated?

#16 - 2017-06-01 17:01 - Bohdan Artemchuk

+1

#17 - 2017-07-27 17:54 - Toshi MARUYAMA

- Description updated

#18 - 2017-07-27 17:55 - Toshi MARUYAMA

- Has duplicate Feature #26553: Overly restricted number of ReST results added

#19 - 2018-01-02 12:57 - Michael Gerz

What happened to this patch? Nothing?

#20 - 2018-04-30 08:45 - Jose Luis Parrilla

+1

#21 - 2018-09-09 20:35 - Гордеев Алексей

Silence... :(

#22 - 2019-02-17 06:15 - Yuuki NARA

+1

I think that it should be changeable by the responsibility of the system administrator.

There are many configuration items in the world system that may cause troubles due to setting change contents.

Since there are cases where it is necessary to change these items, it is made public after clearly stating that there is a risk when changing.

It is enough to specify the following points.

If you change the default value, there is a possibility of trouble in the operation of REST using application.

The operation verification responsibility is on Redmine system administrator who changed.

#23 - 2019-03-01 11:18 - C F

+1

#24 - 2019-03-28 16:43 - Gianni Cavallotto

+1

#25 - 2019-09-18 08:03 - int redmine

+1

#26 - 2019-10-16 13:48 - Meiki Neumann

+1

#27 - 2019-10-17 03:34 - r okui

+1

#28 - 2019-10-17 07:44 - Cédric Berger
+1

#29 - 2020-05-29 17:40 - Mischa The Evil

- Has duplicate Feature #33526: Add possibility to configure limit used to retrieve objects for an API response added

#30 - 2020-05-29 18:39 - VVD VVD

Russian translation of:

setting_api_limit: Maximum number of items returned in a JSON/XML API response

 is

setting_api_limit: Максимальное количество элементов, передаваемых в ответе JSON/XML API

#31 - 2020-06-15 19:54 - VVD VVD

What blocks this change?

#32 - 2020-07-08 16:18 - Txinto Vaz

+1

#33 - 2020-07-27 19:02 - VVD VVD

meineerde from IRC #redmine@freenode ask me to describe my use-case.

Sorry for my poor english, but I try to explain why this feature is important for me.

We are using Redmine for manage projects - tasks, issues, bugtracker. 10-20 active projects with hundreds active issues and 100+ active users -

employees and customers. Employees are using "Spent time" in issues to record work time for every issue every day. The employees' salary

depends on those records.

We have developed application on Java+Tomcat for create reports with values from "Spent time" fields. It using REST API to get values:

http://redmine.host/time_entries.json?spent_on=><BEGIN_OF_MONTH|END_OF_MONTH&offset=N&limit=10000

For example to get 20000 objects - 200 requests in ~3 minutes even on localhost. But it's faster with limit 10000 - ~20 seconds only.

After end of each month 10+ project managers (I'm one of them) using this application to create reports for each project. The employees salary

calculated from this reports. Every mouth we have thousands of "Spent time" entries. It's too long for users wait several minutes for "simple" report,

and even more - some browsers timedout connection during this time…    

Please, commit this patch!

#34 - 2020-10-24 10:02 - vzvu 3k6k

- File 0001-domingo-galdos.patch added

- File 0002-add-test.patch added

- File 0003-move-to-api-tab.patch added

- File 0004-simplify-label.patch added

- File 0005-quickfix-allow-less-than-25.patch added

Looks good. We've wrote a patch based on Domingo Galdos' one (Patch 0001) with Juno NISHIZAKI, sanak and me on Redmine patch meeting 4th.

The changes are as follows:

Added a test. (Patch 0002)

Moved the configuration value form from the "General" tab to the "API" tab and shorten the label name. (Patch 0003, 0004)

In the current implementation, if the limit parameter is less than 1, Redmine sets limit to 25.  the limit is less than 25, the conditional statement is

modified to be replaced by another one. (Patch 0005)

Go MAEDA wrote:

The user should not be able to set the value of API limit smaller than 100.

Probably some clients suppose that the value is always 100, smaller limit may affect compatibility with such clients.

 Sounds reasonable, but currently the setting page doesn't have any validations. Do you have any good idea to apply the constraint?
#35 - 2020-10-26 08:10 - Mizuki ISHIKAWA

- File Add-validation-to-api-limit.patch added

vzvu 3k6k wrote:

Go MAEDA wrote:

The user should not be able to set the value of API limit smaller than 100.

Probably some clients suppose that the value is always 100, smaller limit may affect compatibility with such clients.

 Sounds reasonable, but currently the setting page doesn't have any validations. Do you have any good idea to apply the constraint?

 The attached patch adds validation, though it may not be the best way to write it.

#36 - 2020-10-26 22:05 - Marius BĂLTEANU

- Target version changed from Candidate for next major release to 4.2.0

The final result of the patch series posted by vzvu 3k6k and Mizuki looks good to me and all the tests pass: 

https://gitlab.com/redmine-org/redmine/-/pipelines/207877707

I propose to evaluate this for 4.2.0, but we should have Jean-Philippe agree on this because he rejected the patch some time ago. The feature is

useful, for sure.

#37 - 2021-03-17 18:11 - Roberto Mendes

I need this. To get more than 100 items.

#38 - 2021-03-23 21:42 - Marius BĂLTEANU

- Target version changed from 4.2.0 to 5.0.0

#39 - 2022-03-18 19:43 - Marius BĂLTEANU

- Target version changed from 5.0.0 to Candidate for next major release

#40 - 2023-01-21 08:56 - Go MAEDA

- Related to Feature #38173: Increase limit of entries in json/xml and, preferably, make it configurable added

#41 - 2023-06-15 09:56 - Maciej Czechowicz

Is it possible to push this request? I have application which sends 13 requests to Redmine and takes internity for that.

#42 - 2024-09-09 13:51 - Marco Descher

+1

#43 - 2025-02-05 12:23 - Sebastian Schuh

+1

#44 - 2025-02-24 17:35 - Micael Broun

+1

Files

0001-domingo-galdos.patch 1.93 KB 2020-10-24 vzvu 3k6k

0002-add-test.patch 658 Bytes 2020-10-24 vzvu 3k6k

0004-simplify-label.patch 643 Bytes 2020-10-24 vzvu 3k6k

0003-move-to-api-tab.patch 905 Bytes 2020-10-24 vzvu 3k6k

0005-quickfix-allow-less-than-25.patch 544 Bytes 2020-10-24 vzvu 3k6k

Add-validation-to-api-limit.patch 1.41 KB 2020-10-26 Mizuki ISHIKAWA
